
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.table.*;

/**
 * Description:  Classe che implementa l'interfaccia grafica del Listino
 * @author       Virgilio Pierini
 */

public class Interfaccia extends JDialog {
  JPanel contentPane;
  BorderLayout borderLayout1 = new BorderLayout();
  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenuFile = new JMenu();
  JMenuItem jMenuItemExit = new JMenuItem();
  JMenu jMenuHelp = new JMenu();
  JMenuItem jMenuItemInfo = new JMenuItem();
  JPanel jPanel1 = new JPanel();
  JButton ButtonGO = new JButton();
  ModelloTabella mt = new ModelloTabella();
  JTable Tabella = new JTable(mt);
  JPanel jPanel2 = new JPanel();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  GridLayout gridLayout1 = new GridLayout();
  TitledBorder titledBorder1;
  TitledBorder titledBorder2;

  Listino agent;

 /**
  * @param a un agentedi tipo Listino che verr chiamato (tramite CALLBACK)
  * per la memorizzazione delle coppie oggetto-valore impostate dall'utente
  */
  public Interfaccia(Listino a) {
   super((Frame)null,"Listino", true);
    agent=a;
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception  {
    titledBorder1 = new TitledBorder("");
    titledBorder2 = new TitledBorder("");
    contentPane = (JPanel) this.getContentPane();
    setTitle("Listino");
    contentPane.setLayout(borderLayout1);
    borderLayout1.setHgap(20);

    jMenuFile.setText("File");
    jMenuItemExit.setText("Exit");
    jMenuItemExit.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemExit_actionPerformed(e);
      }
    });

    jMenuHelp.setText("Help");
    jMenuItemInfo.setText("Info");
    jMenuItemInfo.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItemInfo_actionPerformed(e);
      }
    });

    Tabella.setBackground(SystemColor.desktop);
    Tabella.setForeground(Color.white);
    Tabella.setBorder(BorderFactory.createLineBorder(Color.black));
    Tabella.setMaximumSize(new Dimension(240, 160));
    Tabella.setMinimumSize(new Dimension(240, 160));
    Tabella.setPreferredSize(new Dimension(240, 160));
    Tabella.setGridColor(Color.black);
    DefaultCellEditor dce=new DefaultCellEditor(new JTextField());
    dce.setClickCountToStart(1);
    Tabella.setDefaultEditor(Number.class,dce);
    Tabella.setDefaultEditor(String.class,dce);
    Tabella.setCellSelectionEnabled(true);

    jLabel1.setBorder(titledBorder1);
    jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel1.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel1.setText("Costo");
    jLabel2.setBorder(titledBorder2);
    jLabel2.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel2.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel2.setText("Nome");
    jPanel2.setLayout(gridLayout1);
    gridLayout1.setColumns(2);
    gridLayout1.setHgap(4);
    jMenuBar1.add(jMenuFile);
    jMenuBar1.add(jMenuHelp);
    jMenuFile.add(jMenuItemExit);
    jMenuHelp.add(jMenuItemInfo);
    this.setJMenuBar(jMenuBar1);

    ButtonGO.setText("GO!");
    ButtonGO.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        ButtonGO_actionPerformed(e);
      }
    });

    contentPane.add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(ButtonGO, null);
    contentPane.add(Tabella, BorderLayout.CENTER);
    contentPane.add(jPanel2, BorderLayout.NORTH);
    jPanel2.add(jLabel2, null);
    jPanel2.add(jLabel1, null);

    pack();
  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
     jMenuItemExit_actionPerformed(null);
    else
     super.processWindowEvent(e);
  }

  void jMenuItemExit_actionPerformed(ActionEvent e) {
    if (JOptionPane.showConfirmDialog(this,"Sicuro?","Listino Conferma",
         JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
     agent.agentSystem.getOut().println("LISTINO: unavailable.");
     hide(); }
  }

  void jMenuItemInfo_actionPerformed(ActionEvent e) {
   JOptionPane.showMessageDialog(this,
    "Impostare i valori dei prezzi dei vari articoli "+
    "e poi confermare per avviare il servizio.",
    "Listino Help",JOptionPane.INFORMATION_MESSAGE);
  }

  public Insets getInsets() { return new Insets(30,10,10,10); }

  void ButtonGO_actionPerformed(ActionEvent e) {
   agent.inserisci(Tabella);
   hide();
 }

}
