
import javax.swing.*;
import java.awt.*;
import java.util.*;
import SOMA.agent.*;

/**
 * Description:  Agente che espone come oggetto condiviso il listino prezzi
 * @author Virgilio Pierini
 */

public class Listino extends Agent {

 /* indica se c' almeno un oggetto nel listino */
  private boolean valori=false;

 /**
  * Viene prima preparata e messa in esecuzione l'interfaccia grafica
  * Poi avviene la memorizzazione e condivisione dei dati utente
  */

  public void run() {
   agentSystem.getOut().println("LISTINO: preparazione dell'interfaccia...");
   Interfaccia i = new Interfaccia(this);
   i.pack();
   Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
   Dimension iSize = i.getSize();
   if (iSize.height > screenSize.height) iSize.height = screenSize.height;
   if (iSize.width > screenSize.width) iSize.width = screenSize.width;
   i.setLocation((screenSize.width - iSize.width) / 2, (screenSize.height - iSize.height) / 2);
   agentSystem.getOut().println("LISTINO: attesa del completamento dell'inserimento dei dati.");
   i.show();

   if (valori) { agentSystem.getOut().println("LISTINO: idle..."); idle("remove");}
   else agentSystem.getOut().println("LISTINO: nessun listino memorizzato.");
  }

 /**
  * Metodo chiamato tramite CALLBACK dall'interfaccia grafica del listino
  * Inserisce in "agentSystem.sharedObjects" la tabella dei prezzi
  * @param Tabella oggetto che contiene i dati inseriti dall'utente
  */
  void inserisci(JTable Tabella) {
   java.io.PrintStream o=agentSystem.getOut();
   Hashtable prezzi=new Hashtable();

   o.println("LISTINO: hashing...");
   for (int k=0;k<10;k++) {
    if (((Double)Tabella.getValueAt(k,1)).doubleValue()>=0) {
     valori=true;
     o.println("LISTINO: ipostato l'oggetto<<"+Tabella.getValueAt(k,0)+">> con costo "+Tabella.getValueAt(k,1));
     prezzi.put(Tabella.getValueAt(k,0),Tabella.getValueAt(k,1));
    }
   }

   if (valori) {
    agentSystem.sharedObjects.put("Prezzi",prezzi);
    o.println("LISTINO: listino disponibile."); }
   else o.println("LISTINO: listino non disponibile (nulla da vendere!).");
 }

 /**
  * Metodo richiamato all'uscita dallo stato IDLE
  * Rimuove il listino memorizzato in modo da poterne creare uno nuovo
  */
  public void remove() {
   agentSystem.sharedObjects.remove("Prezzi");
   agentSystem.getOut().println("LISTINO: listino rimosso.");
  }

}
