
import java.io.*;
import java.util.*;
import SOMA.agent.*;
import SOMA.naming.*;
import java.lang.reflect.*;

/**
 * Description:  Agente che ricerca nei vari listini il costo minimo di un oggetto
 * Utilizzo : messo IDRicerca Oggetto DominioDiRicerca PlaceDeiRisultati
 * @author       Virgilio Pierini
 */

public class Messo extends Agent {

 /** Place da visitare */
 PlaceID[] vettorePlaces;
 /** Place che offre l'oggetto a costo minimo */
 PlaceID placeMinimo;
 /** Place dove consegnare i risultati */
 PlaceID placeDeiRisultati;
 /** Default Place della ricerca */
 PlaceID dominioDiRicerca;
 /** oggetto da cercare*/
 String oggetto;
 /** costo dell'oggetto*/
 double costoMinimo=-1;

 int IDRicerca,posizione=0;
 String IO;


  public void putArgument(Object o)
   {
    try {
     IDRicerca=Integer.parseInt(((String[])o)[0]);
     oggetto=(((String[])o)[1]);
     dominioDiRicerca=new PlaceID(((String[])o)[2]);
     placeDeiRisultati=new PlaceID(((String[])o)[3]);
    } catch (NameException e) { e.printStackTrace();
                               // valori fittizi per creare ugualmente l'agente
                               dominioDiRicerca=agentSystem.getPlaceID();
                               placeDeiRisultati=agentSystem.getPlaceID(); }
   }

  public void run() {
   PrintStream o=agentSystem.getOut();
   IO="Messo"+ getID().toString();

   //spostamento al dominio di ricerca
   o.println(IO+" mi sposto su "+dominioDiRicerca);
   if (dominioDiRicerca.equals(agentSystem.getPlaceID()))
    inizia();
   else
    try { go(dominioDiRicerca,"inizia"); }
    catch (SOMA.agent.CantGoException e) {e.printStackTrace(o);}
  }

  /** Posto nel dominio di ricerca recupera l'elenco dei place da visitare */
  public void inizia() {
   PrintStream o=agentSystem.getOut();

   //ricerca vera e propria
   vettorePlaces=ordinaPlaces(agentSystem.getPlaces());
   o.println(IO+" inizio a cercare <<"+oggetto+">>");
   o.println(IO+"   vedo "+vettorePlaces.length+" places:");
   for (int k=0;k<vettorePlaces.length;k++)
   o.println(IO+ "     "+k+") "+vettorePlaces[k].toString());

   visita();
  }

  /** Elaborazione locale ad ogni place */
  public void visita() {
   PrintStream o=agentSystem.getOut();

   o.println(IO+" controllo i prezzi...");
   Hashtable prezzi=(Hashtable)agentSystem.sharedObjects.get("Prezzi");

   if (prezzi==null) o.println(IO+" qui non si vende nulla :(");
   else {
    Double costo=(Double)prezzi.get(oggetto);
    if (costo==null)
     o.println(IO+" qui non si vendono <<"+oggetto+">>");
    else {
     o.println(IO+" qui un <<"+oggetto+">> costa "+costo);
     if ((costoMinimo<0)||(costo.doubleValue()<costoMinimo)) {
      costoMinimo=costo.doubleValue();
      placeMinimo=agentSystem.getPlaceID();
      o.println(IO+" MI INTERESSA"); }
     else
      o.println(IO+" NON MI INTERESSA");
    }
   }

   /* continua a cercare di andare da qualche parte scorrendo tutti i places
    successivi fino all'ultimo. se fallisce anche questo allora muore
    definitivamente segnalando il problema */
   while (vettorePlaces.length>=posizione) {
    posizione++;
    if (vettorePlaces.length>posizione) {
     o.println(IO+" vediamo sul place "+posizione+"...");
     try { this.go(vettorePlaces[posizione],"visita"); }
     catch (SOMA.agent.CantGoException e) {e.printStackTrace(o);}
    } else {
     o.println(IO+" fine! consegno il risultato...");
     try { this.go(placeDeiRisultati,"fine"); }
     catch (SOMA.agent.CantGoException e) {e.printStackTrace(o);}
    }
   } //while
   o.println(IO+" non sono riuscito a spostarmi da nessuna parte. perso!");
  }

  /** Terminata l'elaborazione aggiorna il Risultato */
  public void fine() {
   PrintStream o=agentSystem.getOut();
   Hashtable risultati=(Hashtable)agentSystem.sharedObjects.get("Risultati");
   //Risultato r;
   Object r=null;

   try {

   if (risultati==null) o.println(IO+" impossibile registrare il risultato!");
   else {
     r=(risultati.get(new Integer(IDRicerca)));
     if (r==null) o.println(IO+" ID mancante!");
     else {

      Method mio_notfound=r.getClass().getMethod("notfound",null);
      Class[] parameters=new Class[2];
      parameters[0]=double.class;
      parameters[1]=PlaceID.class;
      Method mio_found=r.getClass().getMethod("found",parameters);

      if (costoMinimo<0) {
       o.println(IO+" l'oggetto <<"+oggetto+">> non si vende da nessuna parte :(");
       mio_notfound.invoke(r,null);
       //r.notfound();
      } else {
       o.println(IO+" l'oggetto <<"+oggetto+">> costa "+costoMinimo+" sul place "+placeMinimo);
       Object[] p=new Object[2];
       p[0]=new Double(costoMinimo);
       p[1]=placeMinimo;
       mio_found.invoke(r,p);
       //r.found(costoMinimo,placeMinimo);
      }
     }
   }
   o.println(IO+" riposo ;)");
   } catch (Exception e) { e.printStackTrace(); }
  }


  /**
   * Ordina l'elenco di Places che viene fornito dal PNS in modo che al top
   * della lista ci sia il Default Place. In questo modo  garantito che una
   * scansione lineare del vettore cos ordinano permette di visitare tutti
   * i place di un certo dominio una ed una sola volta
   */

  protected PlaceID[] ordinaPlaces(PlaceID[] in) {
   PlaceID[] out=new PlaceID[in.length];
   PlaceID current=agentSystem.getPlaceID();
   out[0]=current;
   int outPos=1;
   for(int k=0;k<in.length;k++) if (!in[k].equals(current)) out[outPos++]=in[k];
   return out;
  }
}
