
import javax.swing.table.*;

/**
 * Description:  Classe che implementa la memorizzazione e gestione dei dati del Listino
 * @author       Virgilio Pierini
 */

public class ModelloTabella extends AbstractTableModel {

  /** nomi degli oggetti in Listino */
  String[] nomi;

  /** costi degli oggetti in Listino */
  Double[] costi;


 /** Inizializza il listino con un unico oggetto ("TRENINO - 50") presente */
  public ModelloTabella() {
   nomi = new String[10];
   costi = new Double[10];

   nomi[0]="TRENINO"; costi[0]=new Double(50);
   for (int k=1;k<10;k++) { nomi[k]="(unused)"; costi[k]=new Double(-1); }
  }


  public int getColumnCount() { return 2; }

  public int getRowCount() { return 10;}

  public boolean isCellEditable(int rowIndex, int columnIndex) { return true; }

  public Class getColumnClass(int columnIndex) {
   switch(columnIndex) {
    case 0: return String.class;
    case 1: return Double.class;
    default: return Object.class;
   }
  }

  public Object getValueAt(int row, int col) {
   switch(col) {
    case 0: return nomi[row];
    case 1: return costi[row];
    default: return null;
   }
  }

 /**
  * Nel caso di inserimento di un costo si accerta della correttezza
  * del formato numerico, eventualmente annullando la modifica
  */

  public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
   switch(columnIndex) {
    case 0: nomi[rowIndex]=(String)aValue; return;
    case 1: try { costi[rowIndex]=new Double(Double.parseDouble((String)aValue)); }
            catch (java.lang.NumberFormatException e) {}
            finally { return; }
    default: return;
   }
  }
}
