
import java.io.*;
import java.net.*;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 * Description: Servlet per il recupero dei risultati
 * @author Virgilio Pierini
 * @version 1.0
 */

public class Risultati extends HttpServlet {

 /** Esprime in decimi di secondo il tempo prima del refresh automatico della card */
 final int timeout = 50;

  /**
   * Recupera l'elenco dei risultati associati ad un certo username.
   * Pu essere stesa per il recupero di singole ricerche e per gestire utenti non autorizzati.
   */

  public void doGet(HttpServletRequest request, HttpServletResponse response)
  throws IOException, ServletException {
  Socket s;
  PrintStream sout;
  BufferedReader sin;

  String username=request.getParameter("username");
  if (username==null) username=""; //per semplicit

   response.setContentType("text/vnd.wap.wml");
   PrintWriter out=response.getWriter();
   out.println("<?xml version=\"1.0\"?>");
   out.println("<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.1//EN\" \"http://www.wapforum.org/DTD/wml_1.1.xml\">");
   out.println("<wml>");
   out.println("<card id=\"Risultati\" ontimer=\"/risultati?username="+username+"\" title=\"Risultati\">");
   out.println("<timer value=\""+timeout+"\"/>");
   out.println("<p>");

   if (username.equals("")) { out.println("<big>Error in session!!!</big>"); }
   else {

    out.print("Results for<br/><big>");
    out.print(username);
    out.println("</big><br/>");

    try {
     s=new Socket(InetAddress.getLocalHost(),8000);
     sout=new PrintStream(s.getOutputStream());
     sin=new BufferedReader(new InputStreamReader(s.getInputStream()));
     sout.println(username);
     if (!sin.readLine().equals("OK")) { /* utente non autorizzato */  }
     else { /* utente autorizzato */
      sout.println("ALL");
      String riga;
      do {
      riga=sin.readLine();
      out.println(WAPcompliant(riga)+"<br/>");
      } while (!riga.equals(".end."));

      //link alla richiesta di una nuova ricerca
      out.println("<br/>press to issue a new service...");
      out.println("<do type=\"accept\" label=\"Service\">");
      out.println("<go href=\"/servizi\">");
      out.println("<postfield name=\"username\" value=\""+username+"\"/>");
      out.println("</go>");
      out.println("</do>");
     } /* fine utente autorizzato */

     s.close();
    } catch (Exception e) { out.println("<big>ERROR!!!</big><br/>"); }
   }

   out.println("</p>");
   out.println("</card>");
   out.println("</wml>");

   out.close();
  }


  /**
   * Elabora i caratteri speciali del wml (ad es '<' e '>') rendendoli stampabili
   */

  String WAPcompliant(String in) {
   return in.replace('<',' ').replace('>',' ');
  }
}
