
import java.io.*;
import java.net.*;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 * Description:  Servlet di richiesta di un servizio
 * @author Virgilio Pierini
 * @version 1.0
 */

public class Servizi extends HttpServlet {

  /**
   * Richiede all'utente l'oggetto da cercare.
   */

  public void doGet(HttpServletRequest request, HttpServletResponse response)
  throws IOException, ServletException {

   String username=request.getParameter("username");
   if (username==null) username=""; //per semplicit

   response.setContentType("text/vnd.wap.wml");
   PrintWriter out=response.getWriter();
   out.println("<?xml version=\"1.0\"?>");
   out.println("<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.1//EN\" \"http://www.wapforum.org/DTD/wml_1.1.xml\">");
   out.println("<wml>");
   out.println("<card id=\"Servizi\" title=\"Servizi\">");

   if (username.equals("")) { out.println("<big>Error in session!!!</big>"); }
   else {
    out.println("<p>Servizio di ricerca<br/>inserire l'oggetto da cercare:<br/>");
    out.println("<input type=\"text\" name=\"oggetto\"/><br/>");
    out.println("<do type=\"accept\" label=\"Submit\">");
    out.println("<go href=\"/servizi\" method=\"post\">");
    out.println("<postfield name=\"username\" value=\""+username+"\"/>");
    out.println("<postfield name=\"oggetto\" value=\"$oggetto\"/>");
    out.println("</go>");
    out.println("</do>");
   }

   out.println("</p>");
   out.println("</card>");
   out.println("</wml>");

   out.close();
  }


  /**
   * Comunica la risposta del sistema SOMA alla richiesta di avvio.
   * Non ha conoscenza del risultato finale.
   * Pu essere estesa per gestire il caso di utenti non autorizzati a richiedere servizi.
   */

  public void doPost(HttpServletRequest request, HttpServletResponse response)
  throws IOException, ServletException {
  Socket s;
  PrintStream sout;
  BufferedReader sin;

   String username=request.getParameter("username");
   if (username==null) username=""; //per semplicit
   String oggetto=request.getParameter("oggetto");
   if (oggetto==null) oggetto=""; //per semplicit

   response.setContentType("text/vnd.wap.wml");
   PrintWriter out=response.getWriter();
   out.println("<?xml version=\"1.0\"?>");
   out.println("<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.1//EN\" \"http://www.wapforum.org/DTD/wml_1.1.xml\">");
   out.println("<wml>");
   out.println("<card id=\"Servizi\" title=\"Servizi\">");
   out.println("<p>");

   if (username.equals("")) { out.println("<big>Error in session!!!</big>"); }
   else if (oggetto.equalsIgnoreCase("")) { out.println("<big>Invalid object name!!!</big>"); }
   else {
    out.print("Request for<br/><big>");
    out.print(username);
    out.println("</big><br/>completed succesfully:<br/>");

    try {
     s=new Socket(InetAddress.getLocalHost(),8001);
     sout=new PrintStream(s.getOutputStream());
     sin=new BufferedReader(new InputStreamReader(s.getInputStream()));
     sout.println(username);
     if (!sin.readLine().equals("OK")) { /* utente non autorizzato */  }
     else { /* utente autorizzato */
      sout.println(oggetto);
      out.println(sin.readLine()+"<br/>");

      //link alla pagina dei risultati
      out.println("<br/>press to view results...");
      out.println("<do type=\"accept\" label=\"Results\">");
      out.println("<go href=\"/risultati\">");
      out.println("<postfield name=\"username\" value=\""+username+"\"/>");
      out.println("</go>");
      out.println("</do>");
     } /* fine utente autorizzato */

     s.close();
    } catch (Exception e) { out.println("<big>ERROR!!!</big><br/>"); }
   }

   out.println("</p>");
   out.println("</card>");
   out.println("</wml>");

   out.close();
  }

}
